

.586p
.mmx			
.model flat, stdcall
option casemap :none

;******************************************************************************
;* INCLUDES                                                                   *
;******************************************************************************
include				\masm32\include\windows.inc
include				\masm32\include\user32.inc
include				\masm32\include\kernel32.inc
include				\masm32\include\shell32.inc
include				\masm32\include\advapi32.inc
include				\masm32\include\gdi32.inc
include				\masm32\include\comctl32.inc
include				\masm32\include\comdlg32.inc
include				\masm32\include\masm32.inc
include				\masm32\macros\macros.asm

includelib			\masm32\lib\user32.lib
includelib			\masm32\lib\kernel32.lib
includelib			\masm32\lib\shell32.lib
includelib			\masm32\lib\advapi32.lib
includelib			\masm32\lib\gdi32.lib
includelib			\masm32\lib\comctl32.lib
includelib			\masm32\lib\comdlg32.lib
includelib			\masm32\lib\masm32.lib

include				\masm32\include\wsock32.inc
includelib			\masm32\lib\wsock32.lib
include				\masm32\include\wininet.inc
includelib			\masm32\lib\wininet.lib

;include			\masm32\include\diablo2oo2.inc
;includelib			\masm32\lib\diablo2oo2.lib
;******************************************************************************
;* PROTOTYPES                                                                 *
;******************************************************************************
DialogProc 		PROTO :DWORD,:DWORD,:DWORD,:DWORD
edit_proc      		PROTO :DWORD,:DWORD,:DWORD,:DWORD
;******************************************************************************
;* DATA & CONSTANTS                                                           *
;******************************************************************************
.const
DLG_EDIT	equ 101
BTN_OK		equ 102

.data

.data?
old_proc 	dd ?

;******************************************************************************
;* CODE                                                                       *
;******************************************************************************
.code
main:
	invoke GetModuleHandle,0
        invoke DialogBoxParam,eax,1,0,addr DialogProc,0
        invoke ExitProcess,0
        
DialogProc Proc uses ebx esi edi  hwnd:dword,message:dword,wParam:dword,lParam:dword
	mov eax,message
	.if eax==WM_COMMAND
		mov eax,wParam
		.if ax==BTN_OK
			jmp @close
		.endif
	.elseif eax==WM_INITDIALOG
		invoke GetDlgItem,hwnd,DLG_EDIT
		invoke SetWindowLong,eax,GWL_WNDPROC,addr edit_proc
		mov old_proc,eax
	.elseif eax==WM_CTLCOLOREDIT
		invoke GetDlgCtrlID,lParam
		.if ax==DLG_EDIT
			invoke SetBkMode,wParam,TRANSPARENT			;Background of Text
			invoke SetTextColor,wParam,0E3DEDDh			;TextColor
			invoke GetStockObject,NULL_BRUSH
			ret
		.endif
	.elseif eax==WM_CLOSE
		@close:
		invoke EndDialog,hwnd,0
	.endif
	xor eax,eax
	ret 	                         
DialogProc endp

edit_proc proc hwnd:DWORD,umsg:DWORD,wparam:DWORD,lparam:DWORD
	mov eax,umsg
	.if eax==WM_CHAR || eax==WM_KEYDOWN || eax==WM_VSCROLL	|| eax==WM_HSCROLL || eax==WM_MOUSEMOVE
		invoke CallWindowProc,old_proc,hwnd,umsg,wparam,lparam
		invoke GetParent,hwnd
		invoke InvalidateRect,eax,0,0
		ret
	.endif
	invoke CallWindowProc,old_proc,hwnd,umsg,wparam,lparam
	ret
edit_proc endp

end main